<?php


class Chat_realtime {
	
	private $name;
	private $host;
	private $username;
	private $password;
	private $imageDir;
	
	function __construct($name, $host, $username, $password, $imageDir)
    {
        $this->dbh = new PDO('mysql:dbname='.$name.';host='.$host.";port=3306",$username, $password);
		$this->imageDir = $imageDir;
    }
	
	function user_login($user, $avatar){
		$name = htmlspecialchars($user);
		$data = array();
		$sql=$this->dbh->prepare("SELECT name FROM users WHERE name=?");
		$sql->execute(array($name));
		if($sql->rowCount() == 0){
			$upd=$this->dbh->prepare("INSERT INTO users (name,avatar,login,status) VALUES (?,?,NOW(),?)");
			$upd->execute(array($name, $avatar, 'online'));
		}else{
			$upd=$this->dbh->prepare("UPDATE users SET avatar=?, login=NOW(), status=? WHERE name=?");
			$upd->execute(array($avatar, 'online', $name));
		}
		$data['status'] = 'success';
		return $data;
	}
	
	function get_message($tipe, $ke, $user){

		$sql=$this->dbh->prepare("SELECT unix_timestamp(date) as DateToNumber FROM messages ORDER BY id DESC LIMIT 1");
		// $sql->execute(array($tipe));
		while($r = $sql->fetch()){
			
			$last_insert_date = $r['DateToNumber'];
			$token = 'zklrluk883makqd4';
			$instanceId = '194715';
			$url = 'https://eu13.chat-api.com/instance30219/messages?token=gt68er765bycz2d6&_ga=2.177313189.1499785353.1605760703-1790930561.1604685108';
			
			
			date_default_timezone_set("Asia/Karachi");
			$data = json_decode(file_get_contents($url), true);
			foreach($data['messages'] as $message){ // Echo every message
			    // Handle every message here
			    // Add to the database or generate a response
			    if($message['time'] > $last_insert_date){

			    	$myArray = explode('@', $message['chatId']);
			    	$myArray = explode('-', $myArray[0]);

			    	if($message['fromMe'] != '1'){


				    	$sql=$this->dbh->prepare("INSERT INTO messages (name,ke,avatar,message,image,tipe,date) VALUES (?,?,?,?,?,?,?)");

				    	$sql->execute(array($myArray[0],$user,'$avatar',$message['body'],'$image',$message['type'],date("Y-m-d H:i:s", $message['time'])));
			    	}
			    	
			    	$sql=$this->dbh->prepare("SELECT name FROM users WHERE name=?");
	    			$sql->execute(array($myArray[0]));
	    			if($sql->rowCount() == 0){
	    				$upd=$this->dbh->prepare("INSERT INTO users (name,username,avatar,login,status) VALUES (?,?,?,NOW(),?)");
	    				$upd->execute(array($myArray[0],$message['senderName'],'image/user.jpg', 'online'));
	    			}


			    }

			}

		}

		$data = array();
		if($tipe == 'rooms'){
			if($ke == 'all'){
				$sql=$this->dbh->prepare("SELECT * FROM messages WHERE tipe=? order by date DESC");
				$sql->execute(array($tipe));
			}else{
				$sql=$this->dbh->prepare("SELECT * FROM messages WHERE ke=? order by date DESC");
				$sql->execute(array($ke));
			}
			while($r = $sql->fetch()){
				$data[] = array(
					'name' => $r['name'],
					'avatar' => $r['avatar'],
					'message' => $r['message'],
					'image' => $r['image'],
					'tipe' => $r['tipe'],
					'date' => $r['date'],
					'selektor' => $r['ke']
				);
			}
		}else if($tipe == 'users'){
			if($ke == 'all'){
				$sql=$this->dbh->prepare("SELECT * FROM messages WHERE (name = :id1 AND tipe= :id2) OR (ke = :id1 AND tipe = :id2) order by date DESC");
				$sql->execute(array(':id1' => $user, ':id2' => $tipe));
				$tmp = array();
				while($r = $sql->fetch()){
					$name = ($r['name'] == $user ? $r['ke'] : $r['name']);
					if(!in_array($name, $tmp)){
						array_push($tmp, $name);
						$get=$this->dbh->prepare("SELECT * FROM users WHERE name=?");
						$get->execute(array($name));


						$data[] = array(
							'name' => $name,
							'avatar' => $r['avatar'],
							'date' => $r['date'],
							'message' => $r['message'],
							'username' => $get->fetch()['username'],
							// 'status' => $get->fetch()['status'],
							'selektor' => ($r['name'] == $user ? "to" : "from")
						);


					}
				}
			}else{
				$sql=$this->dbh->prepare("SELECT * FROM messages WHERE (name = :id1 AND ke= :id2) OR (name = :id2 AND ke = :id1) order by date DESC");
				$sql->execute(array(':id1' => $user, ':id2' => $ke));
				while($r = $sql->fetch()){
					$data[] = array(
						'name' => $r['name'],
						'avatar' => $r['avatar'],
						'message' => $r['message'],
						'image' => $r['image'],

						'tipe' => $r['tipe'],
						'date' => $r['date'],
						'selektor' => ($r['name'] == $user ? $r['ke'] : $r['name'])
					);
				}
			}
		}
		return $data;
	}
	
	function get_user($user){
		if(isset($user)){
			$sqlm=$this->dbh->prepare("SELECT name FROM users WHERE name=?");
			$sqlm->execute(array($user));
			if($sqlm->rowCount() > 0){
				$upd=$this->dbh->prepare("UPDATE users SET login=NOW() WHERE name=?");
				$upd->execute(array($user));
			}
		}
		$data = array();
		$sql=$this->dbh->prepare("SELECT * FROM users");
		$sql->execute();
		while($r = $sql->fetch()){
			$data["all"][] = array(
				'name' => $r['name'],
				'avatar' => $r['avatar'],
				'login' => $r['login'],
				'username' => $r['username'],
				'status' => $r['status']
			);
		}
		$data["chat"] = $this->get_message("users", "all", $user);
		return $data;
	}
	
	function send_message($name, $ke, $message, $image, $date, $avatar, $tipe){	

		$data = [
            'phone' =>$ke, // Receivers phone
            'body' => $message, // Message
        ];
        $json = json_encode($data); // Encode data to JSON
        
        // URL for request POST /message
        $token = 'zklrluk883makqd4';
		$instanceId = '194715';
        $url = 'https://eu13.chat-api.com/instance30219/messages?token=gt68er765bycz2d6&_ga=2.177313189.1499785353.1605760703-1790930561.1604685108';
        
        //  Make a POST request
        $options = stream_context_create(['http' => [
                'method'  => 'POST',
                'header'  => 'Content-type: application/json',
                'content' => $json
            ]
        ]);
        
        // Send a request
        
        $result = file_get_contents($url, false, $options);	

		$data = array();
		$sql=$this->dbh->prepare("INSERT INTO messages (name,ke,avatar,message,image,tipe,date) VALUES (?,?,?,?,?,?,?)");
		
		$sql->execute(array($name,$ke,$avatar,$message,$image,$tipe,$date));
		$data['status'] = 'success';
		return $data;
	}
	
	function user_logout($name){
		$data = array();
		$user = $this->dbh->prepare("UPDATE users SET status=? WHERE name=?");
		$user->execute(array('offline',$name));
		$data['status'] = 'success';
		return $data;
	}
	
	// upload image
	function arrayToBinaryString($arr) {
		$str = "";
		foreach($arr as $elm) {
			$str .= chr((int) $elm);
		}
		return $str;
	}

	function createImg($string, $name, $type){
		$im = imagecreatefromstring($string); 
		if($type == 'image/png'){
				imageAlphaBlending($im, true);
				imageSaveAlpha($im, true);
			imagepng($im, $this->imageDir.'/'.$name);
		}else if($type == 'image/gif'){
			imagegif($im, $this->imageDir.'/'.$name);
		}else{
			imagejpeg($im, $this->imageDir.'/'.$name);
		}
		imagedestroy($im);
	}
	
}
